//
// General form controls (plus a few specific high-level interventions)
//

.form-control {
    width: 100%;
    display: block;
    height: rem(48);
    font-size: rem(14);
    line-height: rem(18);
    border-radius: rem(8);
    vertical-align: middle;
    padding: rem(14) rem(16);
    color: var(--dark);
    appearance: none;
    background-color: white;
    background-clip: padding-box;
    border: rem(1) solid #DCDCDC;

    textarea {
        height: auto;
    }

    &::placeholder {
        opacity: 1;
        color: #C7C7C7;
    }

    &:focus,
    &:active  {
        outline: none;
        border-color: rgba(1, 118, 246, 0.5);

        &::placeholder {
            opacity: 0;
            color: transparent;
        }
    }

    &[type="file"] {
        overflow: hidden; // prevent pseudo element button overlap

        &:not(:disabled):not([readonly]) {
            cursor: pointer;
        }
    }

    &::-webkit-date-and-time-value {
        margin: 0;
        min-width: 85px;
        height: if(unit($input-line-height) == "", $input-line-height * 1em, $input-line-height);
    }
    &::-webkit-datetime-edit {
        display: block;
        padding: 0;
    }

    &:disabled {
        color: #C7C7C7;
        border-color: #DCDCDC;
        background-color: white;
        opacity: 1;
    }

    &::file-selector-button {
        padding: $input-padding-y $input-padding-x;
        margin: (-$input-padding-y) (-$input-padding-x);
        margin-inline-end: $input-padding-x;
        color: $form-file-button-color;
        @include gradient-bg($form-file-button-bg);
        pointer-events: none;
        border-color: inherit;
        border-style: solid;
        border-width: 0;
        border-inline-end-width: $input-border-width;
        border-radius: 0; // stylelint-disable-line property-disallowed-list
        @include transition($btn-transition);
    }

    &:hover:not(:disabled):not([readonly])::file-selector-button {
        background-color: $form-file-button-hover-bg;
    }

    &.icon-left {
        padding-left: rem(50);
    }

    &.icon-right {
        padding-right: rem(50);
    }
}

textarea.form-control {
    height: auto;
}


.form-control-plaintext {
  display: block;
  width: 100%;
  padding: $input-padding-y 0;
  margin-bottom: 0; // match inputs if this class comes on inputs with default margins
  line-height: $input-line-height;
  color: $input-plaintext-color;
  background-color: transparent;
  border: solid transparent;
  border-width: $input-border-width 0;

  &:focus {
    outline: 0;
  }

  &.form-control-sm,
  &.form-control-lg {
    padding-right: 0;
    padding-left: 0;
  }
}

// Form control sizing
//
// Build on `.form-control` with modifier classes to decrease or increase the
// height and font-size of form controls.
//
// Repeated in `_input_group.scss` to avoid Sass extend issues.

.form-control-sm {
  min-height: $input-height-sm;
  padding: $input-padding-y-sm $input-padding-x-sm;
  @include font-size($input-font-size-sm);
  @include border-radius($input-border-radius-sm);

  &::file-selector-button {
    padding: $input-padding-y-sm $input-padding-x-sm;
    margin: (-$input-padding-y-sm) (-$input-padding-x-sm);
    margin-inline-end: $input-padding-x-sm;
  }
}

.form-control-lg {
  min-height: $input-height-lg;
  padding: $input-padding-y-lg $input-padding-x-lg;
  @include font-size($input-font-size-lg);
  @include border-radius($input-border-radius-lg);

  &::file-selector-button {
    padding: $input-padding-y-lg $input-padding-x-lg;
    margin: (-$input-padding-y-lg) (-$input-padding-x-lg);
    margin-inline-end: $input-padding-x-lg;
  }
}

// Make sure textareas don't shrink too much when resized
// https://github.com/twbs/bootstrap/pull/29124
// stylelint-disable selector-no-qualifying-type
textarea {
  &.form-control {
    min-height: $input-height;
  }

  &.form-control-sm {
    min-height: $input-height-sm;
  }

  &.form-control-lg {
    min-height: $input-height-lg;
  }
}
// stylelint-enable selector-no-qualifying-type

.form-control-color {
  width: $form-color-width;
  height: $input-height;
  padding: $input-padding-y;

  &:not(:disabled):not([readonly]) {
    cursor: pointer;
  }

  &::-moz-color-swatch {
    border: 0 !important; // stylelint-disable-line declaration-no-important
    @include border-radius($input-border-radius);
  }

  &::-webkit-color-swatch {
    border: 0 !important; // stylelint-disable-line declaration-no-important
    @include border-radius($input-border-radius);
  }

  &.form-control-sm { height: $input-height-sm; }
  &.form-control-lg { height: $input-height-lg; }
}
